// created by Josh Heyde
// last updated 21/03/09

#pragma once
#include "C_WorldEntity.h"
#include "C_Vector.h"
#include <vector>

class C_FlockingEntity : public C_WorldEntity
{
public:
	C_FlockingEntity(const int &newGraphicID, const int &newCurrentFrame, const float &newX, const float &newY,
		const int &newSpeed, const int &newRepulsionRange, const int &newVisionRange, const int &newMaxVelocity);
	~C_FlockingEntity();

	// other member functions
	void collisionResult();
	void determineDirection(std::vector <C_WorldEntity*> v_entityVector);
	bool isEnemyOf(C_WorldEntity* other) const;
	void render(const float &currentTime);
	void update();

	// behavioural functions
	C_Vector avoidance(std::vector <C_WorldEntity*> v_entityVector);
	C_Vector alignment(std::vector <C_WorldEntity*> v_entityVector);
	C_Vector cohesion(std::vector <C_WorldEntity*> v_entityVector);
};
