// created by Josh Heyde
// last updated 21/03/09

#pragma once
#include "C_WorldEntity.h"
#include "C_Vector.h"
#include <vector>

class C_FlockingPredator :
	public C_WorldEntity
{
public:
	C_FlockingPredator(const int &newGraphicID, const int &newCurrentFrame, const float &newX, const float &newY,
		const int &newSpeed, const int &newRepulsionRange, const int &visionRange, const int &newMaxVelocity);
	~C_FlockingPredator();

	// member functions
	void collisionResult();
	void determineDirection(std::vector <C_WorldEntity*> v_entityVector);
	bool isEnemyOf(C_WorldEntity* other) const;
	void render(const float &currentTime);
	void update();

	// behavioural algorithms
	C_Vector avoidance(std::vector <C_WorldEntity*> v_entityVector);
	C_Vector alignment(std::vector <C_WorldEntity*> v_entityVector);
	C_Vector cohesion(std::vector <C_WorldEntity*> v_entityVector);
};
