// created by Josh Heyde
// last updated 25/01/09

#pragma once

#include <iostream>

// forward declaration
class C_Rectangle;

// allows the use of BYTE
typedef unsigned char BYTE;

using std::string;

class C_Sprite
{
public:
	C_Sprite(const int &numOfF, const int &fw, const int &fh, const bool &t = true);
	C_Sprite();
	~C_Sprite();
	bool initialise(const string &fileName);
	void render(BYTE *dest, const C_Rectangle &R_dest, int posX, int posY, int &currentFrame);
	void blitNoAlpha(BYTE *destPoint, BYTE* sourcePoint, const C_Rectangle &R_dest, const C_Rectangle &R_source, const C_Rectangle &R_temp);
	void blitAlpha(BYTE *destPoint, BYTE* sourcePoint, const C_Rectangle &R_dest, const C_Rectangle &R_source, const C_Rectangle &R_temp);
	
	// accessor and mutator functions
	const int getWidth() const {return width;}
	void setWidth(const int &newWidth);
	const int getHeight() const {return height;}
	void setHeight(const int &newHeight);
	const int getNumOfFrames() const {return numOfFrames;}
	void setNumOfFrames(const int &newNumOfFrames);
	const int getFrameWidth() const {return frameWidth;}
	void setFrameWidth(const int &newFrameWidth);
	const int getFrameHeight() const {return frameHeight;}
	void setFrameHeight(const int &newFrameHeight);
	const int getTransparency() const {return transparency;}
	void setTransparency(const bool &newTransparency);
private:
	int width;
	int height;
	BYTE *texture;
	int numOfFrames;
	int frameWidth;
	int frameHeight;
	bool transparency;
};