// created by Josh Heyde
// last updated 25/01/09

#pragma once

#include <HAPI_lib.h>
#include "C_Vector.h"

class C_UI
{
public:
	~C_UI();

	// keyboard member functions
	void refreshKeyboard();
	bool isEscPressed();
	bool isQPressed();
	bool isAPressed();
	bool isWPressed();
	bool isSPressed();

	// mouse member functions
	void refreshMouse();
	bool isLeftButtonClicked();
	bool isRightButtonClicked();
	C_Vector getMousePosition();

	// singleton functions
	static void createInput();
	static C_UI& getInput() {return *input;}
	static void deleteInput();

private:
	C_UI();

	static C_UI *input;

	HAPI_TKeyboardData keyData;
	HAPI_TMouseData mData;
};

#define INPUT C_UI::getInput()
